unit mainform;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  EditBtn, ExtCtrls, headersutils;

type

  { TForm1 }

  TForm1 = class(TForm)
    buttonGenerateHeaders1: TButton;
    buttonGenerateHeaders2: TButton;
    buttonNewProject: TButton;
    editAndroidSDKDir: TDirectoryEdit;
    editApacheAnt: TDirectoryEdit;
    editAppName: TEdit;
    editHeadersDir: TDirectoryEdit;
    editJavaPackage: TEdit;
    editJavaProject: TEdit;
    editPATHJava: TDirectoryEdit;
    editProjectDir: TDirectoryEdit;
    editSDKPlatform: TDirectoryEdit;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    Label1: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label3: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure buttonGenerateHeaders1Click(Sender: TObject);
    procedure buttonGenerateHeaders2ChangeBounds(Sender: TObject);
    procedure buttonGenerateHeaders2Click(Sender: TObject);
    procedure buttonNewProjectClick(Sender: TObject);
    procedure buttonGenerateHeadersClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { private declarations }
    procedure LoadGlobalStrings();
    procedure LoadIniFile();
    procedure SaveIniFile();
  public
    { public declarations }
  end; 

var
  Form1: TForm1; 

implementation

{$R *.lfm}

uses IniFiles;

{ TForm1 }

procedure TForm1.buttonGenerateHeadersClick(Sender: TObject);
begin

end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  LoadIniFile;
end;

procedure TForm1.LoadGlobalStrings();
begin
  gJavaPackageName := editJavaPackage.Text;
  gJavaProjectName := editJavaProject.Text;
  gAppName := editAppName.Text;
  gHeadersDir := IncludeTrailingPathDelimiter(editHeadersDir.Directory);
  gProjectDir := IncludeTrailingPathDelimiter(editProjectDir.Directory);
  gAndroidSDKDir := IncludeTrailingPathDelimiter(editAndroidSDKDir.Directory);

  {$ifdef linux}
  gJavaDestDir := Replace(gProjectDir +'/android/src/'+ gJavaPackageName, '.', '\');
  {$else}
  gJavaDestDir := Replace(gProjectDir +'\android\src\'+ gJavaPackageName, '.', '\');
  {$endif}

  gPATHJava := IncludeTrailingPathDelimiter(editPATHJava.Directory);
  gApacheAnt:= IncludeTrailingPathDelimiter(editApacheAnt.Directory);
  gSDKPlatform:= IncludeTrailingPathDelimiter(editSDKPlatform.Directory);
end;

procedure TForm1.LoadIniFile;
var
   IniFile : TIniFile;
begin
   IniFile := TIniFile.Create(ChangeFileExt(Application.ExeName, '.ini'));
   try
     editJavaPackage.Text   := IniFile.ReadString('androidheadersbuilder', 'JavaPackage', 'com.pascal.systeminfo');
     editJavaProject.Text   := IniFile.ReadString('androidheadersbuilder', 'JavaProject', 'SystemInfo4Android');
     editAppName.Text       := IniFile.ReadString('androidheadersbuilder', 'AppName', 'SystemInfo');
     editProjectDir.Text    := IniFile.ReadString('androidheadersbuilder', 'ProjectDir', 'D:\Programs\zeljus\Primjer01\');

     editHeadersDir.Text    := IniFile.ReadString('androidheadersbuilder', 'HeadersDir', 'D:\Programs\zeljus\systeminfo4android\androidapi');
     editPATHJava.Text      := IniFile.ReadString('androidheadersbuilder', 'PATHJava', 'C:\Progra~1\Java\jdk1.6.0_35\bin');
     editApacheAnt.Text     := IniFile.ReadString('androidheadersbuilder', 'ApacheAnt', 'D:\Programs\apache-ant-1.8.4\bin');
     editSDKPlatform.Text   := IniFile.ReadString('androidheadersbuilder', 'SDKPlatform', 'D:\Programs\android-sdk\platforms\android-8');
     editAndroidSDKDir.Text := IniFile.ReadString('androidheadersbuilder', 'AndroidSDKDir', 'D:\Programs\android-sdk\');
   finally
     IniFile.Free;
   end;
end;

procedure TForm1.SaveIniFile;
var
   IniFile : TIniFile;
begin
  IniFile := TIniFile.Create(ChangeFileExt(Application.ExeName, '.ini'));
  try
     IniFile.WriteString('androidheadersbuilder', 'JavaPackage', editJavaPackage.Text);
     IniFile.WriteString('androidheadersbuilder', 'JavaProject', editJavaProject.Text);
     IniFile.WriteString('androidheadersbuilder', 'AppName',editAppName.Text);
     IniFile.WriteString('androidheadersbuilder', 'ProjectDir',     editProjectDir.Text);

     IniFile.WriteString('androidheadersbuilder', 'HeadersDir',  editHeadersDir.Text);
     IniFile.WriteString('androidheadersbuilder', 'PATHJava',    editPATHJava.Text);
     IniFile.WriteString('androidheadersbuilder', 'ApacheAnt',   editApacheAnt.Text);
     IniFile.WriteString('androidheadersbuilder', 'SDKPlatform', editSDKPlatform.Text);
     IniFile.writeString('androidheadersbuilder', 'AndroidSDKDir',  editAndroidSDKDir.Text);
  finally
    IniFile.Free;
  end;
end;

procedure TForm1.buttonNewProjectClick(Sender: TObject);
begin
  LoadGlobalStrings();
  CreateNewAndroidProject();
  try
    ShowMessage('Project created!');
  except
    ShowMessage('Project not created!');
  end;
end;

procedure TForm1.buttonGenerateHeaders1Click(Sender: TObject);
begin
  SaveIniFile();
end;


procedure TForm1.Button1Click(Sender: TObject);
begin

end;

procedure TForm1.buttonGenerateHeaders2ChangeBounds(Sender: TObject);
begin

end;

procedure TForm1.buttonGenerateHeaders2Click(Sender: TObject);
begin
  Close;
end;

end.

